#include <ESP8266WiFi.h>
//#include <WiFiClient.h>
//#include <ESP8266WebServer.h>
#include <ESP8266mDNS.h>
#include <WiFiUdp.h>
#include <ArduinoOTA.h>




const char* ssid = "dougswap";
const char* password = "fusordoug";
/////////////////////////////////////////// tellem stuff
WiFiUDP tport;
WiFiUDP dport;
char packetBuffer[255];
#define DNSPORT 53831 // landns UDP port
#define DATAPORT 42042 // port for PC communication

IPAddress myip; // my ip as assigned by dhcp
IPAddress bcip; // broadcast addr for this network
unsigned char mac[6]; // my mac, I hope
char tellem_string[40]; // What we'll broadcast
unsigned long tellems;
unsigned long errors;
int packetSize; //incoming size info
String UDPstring;

unsigned long loop_millis;
#define MINUTE_MS 60000
unsigned long minute_z; // milliseconds since last tell
#define SECOND_MS 1000
unsigned long second_z;


////////////////////////////////////
void init_ram ()
{
  tellems = errors = 0;
  minute_z = millis();
  
}
////////////////////////////////////

////////////////////////////////////
void build_tellem_string ()
{
  int i;
  String mystring;

//@@@ class String can't 0 pad hex...
// but sprintf and strncpy are lots more lines of code (less rom though)
  mystring = myip.toString();
  mystring += " ESP_";
  for (i=3;i<6;i++) 
  {
    if (16 > mac[i]) mystring += "0"; // yes, it is that dumb    
    mystring += String(mac[i],HEX);
   }
  mystring.toUpperCase(); // because damn, that's what it is on the net for some retarded opsys
  mystring.toCharArray(tellem_string, 39);
}
////////////////////////////////////
void tellem()
{
  tport.beginPacket(bcip,DNSPORT);
  tport.write(tellem_string);
  tport.endPacket(); 
  tellems++; // for grins, count them
//  Serial.println("tellem");
}
////////////////////////////////////
void ditch_incoming()
{ // ignore other broadcasts, maybe stop possible memory leak.
  // You MUST do this with other things on the LAN broadcasting
  // or library loses its mind - 
  packetSize = tport.parsePacket();
  if (packetSize) {
    int len = tport.read(packetBuffer, 254);
  }
}
////////////////////////////////////
void do_reset ()
{

  // reset the power supply
}
////////////////////////////////////
void handle_host ()
{ // see if input, do stuff if so
  packetSize = dport.parsePacket();
  if (packetSize) { // then there's something to do
    int len = dport.read(packetBuffer, 254);
    packetBuffer[len] = 0;
    UDPstring = packetBuffer;
    if (-1 != UDPstring.indexOf('!'))
    {
      do_reset();// do the reset function
      return;
    }
    Serial.print (UDPstring); // send it to the power supply
  // now see if it is going to create a response
    if (-1 != UDPstring.indexOf('?'))
      { // there's a response coming
       delay(500); //@@@ should readbytesuntil or something instead
       len = Serial.readBytesUntil(0x0a,packetBuffer,254);
       packetBuffer[len]=0;
    // send back a reply, to the IP address and port we got the packet from
       dport.beginPacket(dport.remoteIP(), dport.remotePort());
       dport.write(packetBuffer);
       dport.endPacket();
      }



  } // if something to do



}

///////////////////////////////////////////////////////////// Setup //////////////////////////////////
void setup() {
  Serial.begin(9600); // match tp3005 rate
//  Serial.println("Booting");
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  while (WiFi.waitForConnectResult() != WL_CONNECTED) {
 //   Serial.println("Connection Failed! Rebooting..."); // no printing as we're using the port for the power supply
    delay(5000);
    ESP.restart();
  }
  WiFi.macAddress(mac); // get my MAC addr, as it's part of hostname
  myip = WiFi.localIP(); // class and union of dword and 4 bytes
  bcip = myip; // copy net address but
  bcip[3] = 255; // make it broadcast address
  build_tellem_string();
  init_ram();
  tport.begin(DNSPORT); // for tellem
  dport.begin(DATAPORT); // for commands
  delay (300);


/*  ArduinoOTA.onStart([]() {
    Serial.println("otaStart");
  });
  ArduinoOTA.onEnd([]() {
    Serial.println("\notaEnd");
  });
  ArduinoOTA.onProgress([](unsigned int progress, unsigned int total) {
    Serial.printf("otaProgress: %u%%\r", (progress / (total / 100)));
  });
  ArduinoOTA.onError([](ota_error_t error) {
    Serial.printf("otaError[%u]: ", error);
    if (error == OTA_AUTH_ERROR) Serial.println("Auth Failed");
    else if (error == OTA_BEGIN_ERROR) Serial.println("Begin Failed");
    else if (error == OTA_CONNECT_ERROR) Serial.println("Connect Failed");
    else if (error == OTA_RECEIVE_ERROR) Serial.println("Receive Failed");
    else if (error == OTA_END_ERROR) Serial.println("End Failed");
  });
//*/
  
  ArduinoOTA.begin();
  Serial.println("Ready");
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());
}
///////////////////////////////////////////////////////////////// main ////////////////////////////////
void loop() {
  loop_millis = millis(); // just do this once
  
  
  if (loop_millis - minute_z >= MINUTE_MS)
  {
    minute_z = loop_millis; // update for next time
    tellem(); // 1/minute stuff
    yield();
  } //
  
  ditch_incoming(); // must do this or library leaks memory and dies
  yield();
  ArduinoOTA.handle();
  yield();
  handle_host();

  if (loop_millis - second_z >= SECOND_MS)
  {
   second_z = loop_millis;
  // test serial port output
  // Serial.print(errors++);
  // Serial.println (" A bunch of new bits to see which pin the port output is on...");
//   handle_host(); 
  }

}
